#include <bits/stdc++.h>
#include <string>

using namespace std;

int n,k;
int arr[1000005];
int mat[2005][2005];
int br;
int i,j,m,l,kolona,vrsta,v,w;

bool jeste()
{
    kolona=0;
    vrsta=0;
    v=mat[i][j];
    mat[i][j]=-1;
    bool kraj=false;
    for(m=i+1;m<n&&!kraj;m++)
    {
        if(mat[m][j]==v)
        {
            vrsta++;
            mat[m][j]=-1;
        }
        else
            kraj=true;

    }
    kraj=false;
    for(m=j+1;m<n&&!kraj;m++)
    {
        if(mat[i][m]==v)
        {
            kolona++;
            mat[i][m]=-1;
        }
        else
            kraj=true;

    }

    if(kolona==0||vrsta==0)
        return true;

    for(m=i+1;m<=i+vrsta;m++)
        for(l=j+1;l<=j+kolona;l++)
    {
        if(mat[m][l]==v)
            mat[m][l]=-1;
        else
            return false;
    }
    return true;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);

    cin>>n>>k;
    br=0;

    for(i=0;i<n;i++)
        for(j=0;j<n;j++)
            cin>>mat[i][j];

    for(i=0;i<n;i++)
        for(j=0;j<n;j++)
    {
        if(mat[i][j]!=-1)
        {
             w=mat[i][j];

            if(jeste())
            {
                if(arr[w]==0)
                 br++;
                else
                    if(arr[w]==1)
                        br--;
                arr[w]++;
            }
        }
    }

    cout<<br;


    return 0;
}